/******************************************************************************
 *
 *	PalmKart mini
 *	ver 1.3.3
 *	2008.11 / 2009.5
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/



/************************************************
 *	XN[̏
 ***********************************************/
Err
init_screen( void )
{
  UInt16 error, hr_ref_num;
  UInt32 width = 160, height = 160, depth = 8;
  UInt32 rom_ver;
  Boolean color;


  // J[T|[gĂ邩
  WinScreenMode( winScreenModeGet, NULL, NULL, NULL, &color );
  if( ! color )
    return -1;

  // OS5ȂʏȂ
  FtrGet( sysFtrCreator, sysFtrNumROMVersion, &rom_ver );
  if( rom_ver >= PalmRomVer500 )
    Screen.os5 = true;
  else
    Screen.os5 = false;

  // SONỸnC]Cu̗L`FbN
  if( ( error = SysLibFind( sonySysLibNameHR, &hr_ref_num ) ) )
    {
      if( error == sysErrLibNotFound )
        error = SysLibLoad( 'libr', sonySysFileCHRLib, &hr_ref_num );
    }

  if( ! error )
    {
      HROpen( hr_ref_num );
      HRWinScreenMode( hr_ref_num,
                       winScreenModeGet,
                       &Screen.save.width,
                       &Screen.save.height,
                       &Screen.save.depth,
                       NULL );
      // nC]ʂɂȂĂA[]ʂɕύXB
      if( Screen.save.width == 320 )
        HRWinScreenMode( hr_ref_num, winScreenModeSet, &width, &height, NULL, NULL );
      // 8bit colorɐݒ
      WinScreenMode( winScreenModeSet, NULL, NULL, &depth, NULL);
      HRClose( hr_ref_num );
    }
  else
    {
      // nC]CuȂ
      WinScreenMode( winScreenModeGet,
                     &Screen.save.width,
                     &Screen.save.height,
                     &Screen.save.depth,
                     NULL );
      WinScreenMode( winScreenModeSet, &width, &height, &depth, NULL );
    }

  // obNXN[쐬
  Screen.back_h = WinCreateOffscreenWindow( BACK_WIDTH, BACK_HEIGHT, screenFormat, &error );
  ErrFatalDisplayIf( error, "Error Allocating Offscreen" );
  // XN[̃|C^擾
  Screen.back_p = (void *) BmpGetBits( WinGetBitmap( Screen.back_h ) );
  Screen.lcd_p  = (void *) BmpGetBits( WinGetBitmap( WinGetDisplayWindow() ) );

  // XN[NA
  clear_screen();

  return errNone;
}



/************************************************
 *	obNXN[LCDɃRs[
 ***********************************************/
void
copy_buff_to_lcd( void )
{
  int i;
  UInt32 *screen = (UInt32 *) Screen.lcd_p;
  UInt32 *back = (UInt32 *) Screen.back_p;


  if( Screen.os5 )
    {
      RectangleType r = {{ 0, 0 }, { LCD_WIDTH, LCD_HEIGHT }};

      WinCopyRectangle( Screen.back_h, NULL, &r, 0, 0, winPaint );
    }
  else
    {
      for( i = 0; i < GAME_WIN_HEIGHT/2; i++)
        {
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;

          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;

          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;

          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;

          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;

          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;

          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;

          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
          *screen++ = *back++;
        }
    }
}



/************************************************
 *	SʃNA
 ***********************************************/
void
clear_screen( void )
{
  WinSetDrawWindow( Screen.back_h );
  WinSetBackColor( INDEX_WHITE );

  WinEraseWindow();

  WinSetDrawWindow( NULL );
}



/************************************************
 *	r[NA
 ***********************************************/
void
clear_view( void )
{
  RectangleType r = { 0, 28, 160, 64 };


  WinSetDrawWindow( Screen.back_h );
  WinEraseRectangle( &r,0 );

  WinSetDrawWindow( NULL );
}



/************************************************
 *	XvCg\iobNXN[j
 *	n*nhbg 8bit XvCg
 ***********************************************/
void
sprite( Coord x, Coord y, int chr_no )
{
  int i, j, w, h;
  UInt8 *chr = Bmp.ptr[ chr_no ];
  UInt8 *screen = (UInt8 *) Screen.back_p + (UInt16)(y << 7) + (UInt16)(y << 5) + x;


  if( Screen.os5 )
    {
      RectangleType r;

      WinGetBounds( Bmp.handle[ chr_no ], &r );
      WinCopyRectangle( Bmp.handle[ chr_no ], Screen.back_h, &r, x, y, winPaint );
     }
  else
    {
      // TCY擾
      w = Bmp.extent[ chr_no ].x;
      h = Bmp.extent[ chr_no ].y;

      for( i = 0; i < h; i++ )
        {
          for( j = 0; j < w/2; j++ )
            {
              if( *chr != TRANS_COLOR )
                {
                  *screen = *chr;
                }
              screen++; chr++;
              if( *chr != TRANS_COLOR )
                {
                  *screen = *chr;
                }
              screen++; chr++;
            }
          screen += BACK_WIDTH - w;
        }
    }
}



/************************************************
 *	XvCg\iobNXN[j
 *	
 ***********************************************/
void
sprite_num( Coord x, Coord y, int pos )
{
  int i;
  UInt8 *num = Bmp.ptr[ BMP_NUM ];
  UInt8 *screen = (UInt8 *) Screen.back_p + (UInt16)(y << 7) + (UInt16)(y << 5) + x;


  num += pos;

  for( i = 0; i < NUM_HEIGHT; i++ )
    {
      *screen++ = *num++;
      *screen++ = *num++;
      *screen++ = *num++;
      *screen++ = *num++;
      *screen++ = *num++;
      *screen++ = *num++;
      *screen++ = *num++;

      num += 80 - NUM_WIDTH;
      screen += BACK_WIDTH - NUM_WIDTH;
    }
}



///////////////////////////////////////////////////////////////////////////////
