/******************************************************************************
 *
 *	PalmKart mini
 *	ver 1.3.3
 *	2008.11 / 2009.5
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <SonyCLIE.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/

// ʉf[^
// [D揇] [ms] [gHz]
static const int se_data[ sound_cnt ][ SND_LENGTH ] =
{
  { 0, 0, -1 },				// no_sound
  { 10, 5, 880, -1 },			// drift: A
  { 20, 1, 880, -1 },			// max speed: A
  { 30, 10, 220, -1 },			// rough: A
  { 40, 30, 659, 784, 988, -1 },	// turbo: E:G:B
  { 50, 50, 440, 440, -1 },		// countdown1: A
  { 60, 50, 440, 440, 440, 440, -1 },	// countdown2: A
  { 70, 40, 311, 277, -1 },		// crush: D#/C#
  { 80, 50, 494, 494, 494, 440, 440, 440, 392, 392, 392, 349, 349, 349, -1 },	// fall: B/A/G/F
  { 90, 50, 587, 587, 587, 659, 659, 659, -1 },	// lap: D/E
  { 100, 50, 523, 523, 523, 659, 659, 659, 784, 784, 784, 698, 698, 698, 784, 784, 784, 989, 989, 989, -1 }, // goal : C/E/G/F/G/B
  { 1000, 30, 440, -1 },			// click: A
};



/************************************************
 *	SEIIt؂芷
 ***********************************************/
void
change_se( void )
{
  if( Key.keep == KEY_DOWN )
    {
      Sound.on = (Sound.on +1) & 3;
    }
}



/************************************************
 *	ʉZbg
 ***********************************************/
void
set_se( SoundType type )
{
  if( se_data[ type ][0] >= se_data[ Sound.type ][0] && Sound.on & SE_ON )
    {
      Sound.type = type;
      Sound.count = 2;
    }
}



/************************************************
 *	ʉ
 ***********************************************/
void
play_se( void )
{
  SndCommandType cmd;


  if( Sound.type == no_sound ) return;

  cmd.cmd = sndCmdFrqOn;
  cmd.param1 = se_data[ Sound.type ][ Sound.count ];
  cmd.param2 = se_data[ Sound.type ][1];
  cmd.param3 = Sound.volume;

  SndDoCmd( NULL, &cmd, true );

  Sound.count++;
  if( se_data[ Sound.type ][ Sound.count ] == -1 )
    {
      Sound.type = no_sound;
    }
}



